// Copyright (C) 2002-2005 Brett Hartshorn (bhartsho@yahoo.com)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/class.hpp>

#include <Producer/Block>

using namespace boost::python;

namespace PyProd {

void init_Block()
{   class_<Producer::Block, bases<Producer::Referenced>, boost::noncopyable>
    ("Block", no_init)
        .def("block", &Producer::Block::block)
        .def("release", &Producer::Block::release)
        .def("reset", &Producer::Block::reset)
        ;
}
}

