// Copyright (C) 2002-2005 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.

#ifdef __USE_OSX_IMPLEMENTATION__
#include <strings.h>
#include "missing.hpp"
#include <Carbon/Carbon.h>
#undef check
#endif

#include <boost/python.hpp>

#include <Producer/Referenced>
#include <Producer/RenderSurface>
#include <Producer/InputArea>
#include "producer_ptr.hpp"

using namespace boost::python;

namespace PyProd {
void init_InputArea()
{
    class_<Producer::InputArea, Producer::ref_ptr<Producer::InputArea>, bases<Producer::Referenced>, boost::noncopyable> input_area("InputArea", no_init);

    input_area
        .def(init<>())

        .def("addRenderSurface", 
            &Producer::InputArea::addRenderSurface)
        .def("isRealized", 
            &Producer::InputArea::isRealized)

        .def("getNumRenderSurfaces",
            &Producer::InputArea::getNumRenderSurfaces)
        .def("getRenderSurface",
            &Producer::InputArea::getRenderSurface, return_internal_reference<>())

        .def("getNumWindows",
            &Producer::InputArea::getNumWindows)

#ifdef __linux   // XXX Fix this for windows and Mac OS X
        .def("getWindow",
            &Producer::InputArea::getWindow)
        .def("normalizeMouseMotion",
            &Producer::InputArea::normalizeMouseMotion)
        .def("transformMouseMotion",
            &Producer::InputArea::transformMouseMotion)
#endif

        .def("normalizeXY",
            &Producer::InputArea::normalizeXY)

        .def("getExtents",
            &Producer::InputArea::getExtents)
        .def("getCenter",
            &Producer::InputArea::getCenter)
        ;
}
}
