// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.


#include <boost/python/class.hpp>

#include <Producer/Referenced>
#include "producer_ptr.hpp"

using namespace boost::python;

namespace PyProd {

void init_Referenced()
{
    class_<Producer::Referenced, Producer::ref_ptr<Producer::Referenced>, boost::noncopyable> referenced("Referenced", no_init);
    referenced
        .def(init<>())
        .def("ref", 
            &Producer::Referenced::ref)
        .def("unref", 
            &Producer::Referenced::unref)
        .def("unref_nodelete", 
            &Producer::Referenced::unref_nodelete)
        .def("getReferenceCount", 
            &Producer::Referenced::getReferenceCount)
        ;
}
}
