// Copyright (C) 2002-2005 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.


#include <boost/python/class.hpp>

#include <Producer/Timer>

using namespace boost::python;

namespace {
class Timer : public Producer::Timer {
    private:
        int _dummy;
};
}

namespace PyProd {

void init_Timer()
{
    class_<Timer, boost::noncopyable > timer("Timer", no_init);
    timer
        .def(init<>())
        .def("tick",    &Timer::tick)
        .def("delta_s", &Timer::delta_s)
        .def("delta_m", &Timer::delta_m)
        .def("delta_u", &Timer::delta_u)
        .def("delta_n", &Timer::delta_n)
        ;
}
}
