// Copyright (C) 2002-2005 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//
// Updated for OSG 0.9.6 by brett hartshorn, completed adding new methods!!
// Updated for OSG 0.9.7-rc1 by brett hartshorn
// Bugfixes Sep 16 2004 brett hartshorn

#ifdef __USE_OSX_IMPLEMENTATION__
#include <strings.h>
#include "missing.hpp"
#include <Carbon/Carbon.h>
#undef check
#endif

#include <boost/python/class.hpp>
#include <boost/python/scope.hpp>

#include <Producer/VisualChooser>

#include "producer_ptr.hpp"

using namespace boost::python;

namespace PyProd {
void init_VisualChooser()
{
    class_<Producer::VisualChooser, Producer::ref_ptr<Producer::VisualChooser>, bases<Producer::Referenced>, boost::noncopyable>
    visual_chooser("VisualChooser", no_init);
    visual_chooser
        .def("setSimpleConfiguration", &Producer::VisualChooser::setSimpleConfiguration)
        .def("clear", &Producer::VisualChooser::clear)
        .def("setBufferSize", &Producer::VisualChooser::setBufferSize)
        .def("setLevel", &Producer::VisualChooser::setLevel)
        .def("useRGBA", &Producer::VisualChooser::useRGBA)
        .def("useDoubleBuffer", &Producer::VisualChooser::useDoubleBuffer)
        .def("useStereo", &Producer::VisualChooser::useStereo)
        .def("setAuxBuffers", &Producer::VisualChooser::setAuxBuffers)
        // will these do anything, since the implementation in the header file does nothing?
        // or is it important anyhow, if this is subclassed??
    ;
}
}


