// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//
// Not complete - but missing ones probably not needed

#include <boost/python/class.hpp>
#include <boost/python/scope.hpp>
#include <boost/python/enum.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osg/LineSegment>

#include <string>
#include <iostream>

#include "held_ptr.hpp"

#ifdef _STLP_DEBUG
#error "_STLP_DEBUG shouldn't be defined"
#endif

using namespace boost::python;

namespace PyOSG {
void init_LineSegment()
{
    class_<osg::LineSegment, osg::ref_ptr<osg::LineSegment>, bases<osg::Referenced>, boost::noncopyable> linesegment("LineSegment", 
        "LineSegment class for representing a line segment.",
        no_init);

    linesegment
        .def(init<>())
        .def(init<const osg::Vec3&,const osg::Vec3&>())
        .def("set", 
            &osg::LineSegment::set)
        .def("start", 
            (osg::Vec3&(osg::LineSegment::*)()) 
            &osg::LineSegment::start,
            return_internal_reference<>())
        .def("end", 
            (osg::Vec3&(osg::LineSegment::*)()) 
            &osg::LineSegment::end,
            return_internal_reference<>())
        .def("valid", &osg::LineSegment::valid)
        ;
}
} // namespace PyOSG
