// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.

#include <boost/python/class.hpp>

#include <osg/LineStipple>

#include "StateAttribute.hpp"
#include "held_ptr.hpp"

using namespace boost::python;

namespace {
osg::LineStipple * asLineStipple(osg::StateAttribute * self) { return dynamic_cast<osg::LineStipple*>(self); }
}

namespace PyOSG {
void init_LineStipple()
{
    register_castStateAttribute("asLineStipple", &asLineStipple);

    class_<osg::LineStipple, osg::ref_ptr<osg::LineStipple>, bases<osg::StateAttribute> >("LineStipple", no_init)
         .def(init<>())
         .def("setFactor", &osg::LineStipple::setFactor)
         .def("getFactor", &osg::LineStipple::getFactor)
         .def("setPattern", &osg::LineStipple::setPattern)
         .def("getPattern", &osg::LineStipple::getPattern)
         ;
}
}
