// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.

#include <boost/python/class.hpp>

#include <osg/LineWidth>

#include "StateAttribute.hpp"
#include "held_ptr.hpp"

using namespace boost::python;

namespace {
osg::LineWidth * asLineWidth(osg::StateAttribute * self) { return dynamic_cast<osg::LineWidth*>(self); }
}

namespace PyOSG {
void init_LineWidth()
{
    register_castStateAttribute("asLineWidth", &asLineWidth);

    class_<osg::LineWidth, osg::ref_ptr<osg::LineWidth>, bases<osg::StateAttribute> >("LineWidth", no_init)
         .def(init<>())
         .def("setWidth", &osg::LineWidth::setWidth)
         .def("getWidth", &osg::LineWidth::getWidth)
         ;
}
}
