// Copyright (C) 2002-2003 Brett Hartshorn (bhartsho@yahoo.com)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.

#include <boost/python/class.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osg/PointSprite>

#include "held_ptr.hpp"

using namespace boost::python;


namespace PyOSG {
void init_PointSprite()
{
    class_<osg::PointSprite, osg::ref_ptr<osg::PointSprite>, bases<osg::StateAttribute> >
    ("PointSprite", no_init)
        .def(init<>())
        //.def("compare", &osg::PointSprite::compare)
        .def("getModeUsage", &osg::PointSprite::getModeUsage)
        .def("isTextureAttribute", &osg::PointSprite::isTextureAttribute)
        ;
}
}

