// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.

#include <boost/python/class.hpp>

#include <osg/PolygonOffset>

#include "StateAttribute.hpp"
#include "held_ptr.hpp"

using namespace boost::python;

namespace {
osg::PolygonOffset * asPolygonOffset(osg::StateAttribute * self) { return dynamic_cast<osg::PolygonOffset*>(self); }
}

namespace PyOSG {
void init_PolygonOffset()
{
    register_castStateAttribute("asPolygonOffset", &asPolygonOffset);

    class_<osg::PolygonOffset, osg::ref_ptr<osg::PolygonOffset>, bases<osg::StateAttribute> >("PolygonOffset", no_init)
        .def(init<>())
        .def(init<float, float>())

        .def("setFactor", &osg::PolygonOffset::setFactor)
        .def("getFactor", &osg::PolygonOffset::getFactor)
        .def("setUnits", &osg::PolygonOffset::setUnits)
        .def("getUnits", &osg::PolygonOffset::getUnits)
        ;
}
} // namespace PyOSG


