// Wrapper by Brett Hartshorn.  bhartshorn@opart.org
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.


#include <boost/python/class.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osgFX/AnisotropicLighting>

#include "held_ptr.hpp"

using namespace boost::python;


namespace PyOSG {

void init_AnisotropicLighting()
{

    class_<osgFX::AnisotropicLighting, osg::ref_ptr<osgFX::AnisotropicLighting>, bases<osgFX::Effect>, boost::noncopyable > 
        anisotropicLighting("AnisotropicLighting", no_init);

        anisotropicLighting
            // (function return type (path to functions) (function argument types) &address of function)
            .def("getLightingMap", 
                (osg::Image* (osgFX::AnisotropicLighting::*)()) &osgFX::AnisotropicLighting::getLightingMap, return_internal_reference<>())

            .def("setLightingMap", &osgFX::AnisotropicLighting::setLightingMap)

            .def("getLightNumber", &osgFX::AnisotropicLighting::getLightNumber)
            .def("setLightNumber", &osgFX::AnisotropicLighting::setLightNumber)
            .def("setUpDemo", &osgFX::AnisotropicLighting::setUpDemo)
        ;

    }

}

