// Wrapper by Brett Hartshorn.  bhartshorn@opart.org
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.


#include <boost/python/class.hpp>
#include <boost/python/return_internal_reference.hpp>
#include <osgFX/BumpMapping>

#include <osg/Geometry>

#include "held_ptr.hpp"

using namespace boost::python;


namespace PyOSG {

void init_BumpMapping()
{

    class_<osgFX::BumpMapping, osg::ref_ptr<osgFX::BumpMapping>, bases<osgFX::Effect>, boost::noncopyable > 
        bump("BumpMapping", no_init);

        bump
            //get/setLightNumber should be inherited from baseclass Effect
            .def("getDiffuseTextureUnit", &osgFX::BumpMapping::getDiffuseTextureUnit)
            .def("setDiffuseTextureUnit", &osgFX::BumpMapping::setDiffuseTextureUnit)
            .def("getNormalMapTextureUnit", &osgFX::BumpMapping::getNormalMapTextureUnit)
            .def("setNormalMapTextureUnit", &osgFX::BumpMapping::setNormalMapTextureUnit)

            // (function return type (pointer to member functions) (function argument types) &address of function)
            .def("getOverrideDiffuseTexture", 
                (osg::Texture2D* (osgFX::BumpMapping::*)()) &osgFX::BumpMapping::getOverrideDiffuseTexture, return_internal_reference<>())
            .def("setOverrideDiffuseTexture", &osgFX::BumpMapping::setOverrideDiffuseTexture)

            .def("getOverrideNormalMapTexture", 
                (osg::Texture2D* (osgFX::BumpMapping::*)()) &osgFX::BumpMapping::getOverrideNormalMapTexture, return_internal_reference<>())
            .def("setOverrideNormalMapTexture", &osgFX::BumpMapping::setOverrideNormalMapTexture)

            .def("prepareGeometry", &osgFX::BumpMapping::prepareGeometry)
            .def("prepareNode", &osgFX::BumpMapping::prepareNode)
            .def("prepareChildren", &osgFX::BumpMapping::prepareChildren)
            .def("setUpDemo", &osgFX::BumpMapping::setUpDemo)
            ;

    }

}

