// Wrapper by Brett Hartshorn.  bhartshorn@opart.org
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.


#include <boost/python/class.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osgFX/Cartoon>

#include "held_ptr.hpp"

using namespace boost::python;


namespace PyOSG {

void init_Cartoon()
{

    class_<osgFX::Cartoon, osg::ref_ptr<osgFX::Cartoon>, bases<osgFX::Effect>, boost::noncopyable > 
        cartoon("Cartoon", no_init);

        cartoon
            .def("getOutlineColor", &osgFX::Cartoon::getOutlineColor, return_internal_reference<>())
            .def("setOutlineColor", &osgFX::Cartoon::setOutlineColor)
            .def("getOutlineLineWidth", &osgFX::Cartoon::getOutlineLineWidth)
            .def("setOutlineLineWidth", &osgFX::Cartoon::setOutlineLineWidth)
            .def("setUpDemo", &osgFX::Cartoon::setUpDemo)
            //get/setLightNumber should be inherited from Effect
            ;

    }

}

