// Wrapper by Brett Hartshorn.  bhartshorn@opart.org
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.


#include <boost/python/class.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osgFX/Effect>

#include "held_ptr.hpp"

using namespace boost::python;


namespace PyOSG {

void init_Effect()
{

    class_<osgFX::Effect, osg::ref_ptr<osgFX::Effect>, bases<osg::Group>, boost::noncopyable >
        effect("Effect", no_init);

        effect
            .def("effectName", &osgFX::Effect::effectName)
            .def("effectDescription", &osgFX::Effect::effectDescription)
            .def("effectAuthor", &osgFX::Effect::effectAuthor)
            .def("getEnabled", &osgFX::Effect::getEnabled)
            .def("setEnabled", &osgFX::Effect::setEnabled)
            .def("getNumTechniques", &osgFX::Effect::getNumTechniques)

            // (function return type (path to functions) (function argument types) &address of function)
            .def("getTechnique", 
                (osgFX::Technique* (osgFX::Effect::*)(int)) &osgFX::Effect::getTechnique, return_internal_reference<>())

            .def("getSelectedTechnique", &osgFX::Effect::getSelectedTechnique)
            .def("selectTechnique", &osgFX::Effect::selectTechnique)
            ;

    }

}

