#include <boost/python/class.hpp>
#include <boost/python/return_internal_reference.hpp>
#include <boost/python/dict.hpp>

#include <osgFX/Registry>

#include "held_ptr.hpp"

using namespace boost::python;

namespace {
dict getEffectMap(osgFX::Registry& self)
{
    dict map;

    osgFX::Registry::EffectMap emap = self.getEffectMap();
    for (osgFX::Registry::EffectMap::iterator i=emap.begin(); i!=emap.end(); ++i) {
        osg::ref_ptr<osgFX::Effect> ref((osgFX::Effect *) i->second.get());

        map[i->first] = ref;
    }
    return map;
}
}

namespace PyOSG {

void init_Registry()
{

class_<osgFX::Registry, osg::ref_ptr<osgFX::Registry>, bases<osg::Referenced>, boost::noncopyable >
    effect("Registry", no_init);

    effect
        .def("instance",
            &osgFX::Registry::instance,
            return_value_policy<reference_existing_object>())
        .staticmethod("instance")
        .def("getEffectMap",
            &getEffectMap);
        ;
}
}
