// Wrapper by Brett Hartshorn.  bhartshorn@opart.org
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.


#include <boost/python/class.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osgFX/Scribe>

#include "held_ptr.hpp"

using namespace boost::python;


namespace PyOSG {

void init_Scribe()
{

    class_<osgFX::Scribe, osg::ref_ptr<osgFX::Scribe>, bases<osgFX::Effect>, boost::noncopyable > 
        scribe("Scribe", no_init);

        scribe
            .def("getWireframeColor", &osgFX::Scribe::getWireframeColor, return_internal_reference<>())
            .def("setWireframeColor", &osgFX::Scribe::setWireframeColor)
            .def("getWireframeLineWidth", &osgFX::Scribe::getWireframeLineWidth)
            .def("setWireframeLineWidth", &osgFX::Scribe::setWireframeLineWidth)
            .def("setUpDemo", &osgFX::Scribe::setUpDemo)
            ;

    }

}

