// Wrapper by Brett Hartshorn.  bhartshorn@opart.org
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.


#include <boost/python/class.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osgFX/SpecularHighlights>

#include "held_ptr.hpp"

using namespace boost::python;


namespace PyOSG {

void init_SpecularHighlights()
{

    class_<osgFX::SpecularHighlights, osg::ref_ptr<osgFX::SpecularHighlights>, bases<osgFX::Effect>, boost::noncopyable > 
        specular("SpecularHighlights", no_init);

        specular
            .def("getTextureUnit", &osgFX::SpecularHighlights::getTextureUnit)
            .def("setTextureUnit", &osgFX::SpecularHighlights::setTextureUnit)
            .def("getSpecularColor", &osgFX::SpecularHighlights::getSpecularColor, return_internal_reference<>())
            .def("setSpecularColor", &osgFX::SpecularHighlights::setSpecularColor)
            .def("getSpecularExponent", &osgFX::SpecularHighlights::getSpecularExponent)
            .def("setSpecularExponent", &osgFX::SpecularHighlights::setSpecularExponent)
            .def("setUpDemo", &osgFX::SpecularHighlights::setUpDemo)
            ;

    }

}

