// Wrapper by Brett Hartshorn.  bhartshorn@opart.org
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.


#include <boost/python/class.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osgFX/Technique>

#include "held_ptr.hpp"

using namespace boost::python;


namespace PyOSG {

void init_Technique()
{

    class_<osgFX::Technique, osg::ref_ptr<osgFX::Technique>, bases<osg::Referenced>, boost::noncopyable > 
        technique("Technique", no_init);

        technique
            .def("techniqueName", &osgFX::Technique::techniqueName)
            .def("techniqueDescription", &osgFX::Technique::techniqueDescription)
            .def("getRequiredExtensions", &osgFX::Technique::getRequiredExtensions)
            .def("validate", &osgFX::Technique::validate)
            .def("getNumPasses", &osgFX::Technique::getNumPasses)
            .def("techniqueName", &osgFX::Technique::techniqueName)
            
            // (function return type (path to functions) (function argument types) &address of function)
            .def("getPassStateSet", 
                (osg::StateSet* (osgFX::Technique::*)(int)) &osgFX::Technique::getPassStateSet, return_internal_reference<>())


            ;

    }

}

