// Copyright (C) 2002-2003 Brett Hartshorn (bhartshorn@opart.org)
// Copyright (C) 2005 Gideon May
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python.hpp>

#include <string>
#include <iostream>

using namespace boost::python;

namespace PyOSG {

void init_Technique();
void init_Effect();
void init_AnisotropicLighting();
void init_BumpMapping();
void init_Cartoon();
void init_Scribe();
void init_SpecularHighlights();
void init_Registry();

void __init_osgFX()
{

    init_Technique();
    init_Effect();
    init_AnisotropicLighting();
    init_BumpMapping();
    init_Cartoon();
    init_Scribe();
    init_SpecularHighlights();
    init_Registry();

}
}

BOOST_PYTHON_MODULE(_osgFX)
{
    PyOSG::__init_osgFX();
    scope().attr("__module__") = "PyOSG.osgFX";
    scope().attr("__name__") = "PyOSG.osgFX";
}

#include "module_tail.hpp"

