// Copyright (C) 2002-2005 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/class.hpp>
#include <boost/python/scope.hpp>
#include <boost/python/enum.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osgParticle/ParticleEffect>
#include <osgParticle/ExplosionDebrisEffect>

#include "held_ptr.hpp"

using namespace boost::python;

namespace PyOSGParticle {
void init_ExplosionDebrisEffect()
{
    class_<osgParticle::ExplosionDebrisEffect, osg::ref_ptr<osgParticle::ExplosionDebrisEffect>, bases<osgParticle::ParticleEffect> > explosionDebrisEffect("ExplosionDebrisEffect",
        no_init);

    explosionDebrisEffect.def(init<>());
    explosionDebrisEffect.def(init<osg::Vec3&>());
    explosionDebrisEffect.def(init<osg::Vec3&, float>());
    explosionDebrisEffect.def(init<osg::Vec3&, float, float>());

    explosionDebrisEffect.def("setDefaults",
            &osgParticle::ExplosionDebrisEffect::setDefaults);

    explosionDebrisEffect.def("setUpEmitterAndProgram",
            &osgParticle::ExplosionDebrisEffect::setUpEmitterAndProgram);

    explosionDebrisEffect.def("getEmitter",
            (osgParticle::Emitter * (osgParticle::ExplosionDebrisEffect::*)())
            &osgParticle::ExplosionDebrisEffect::getEmitter,
            return_value_policy<manage_osg_object>());

    explosionDebrisEffect.def("getProgram",
            (osgParticle::Program * (osgParticle::ExplosionDebrisEffect::*)())
            &osgParticle::ExplosionDebrisEffect::getProgram,
            return_value_policy<manage_osg_object>());
}}




