// Copyright (C) 2002-2005 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/class.hpp>
#include <boost/python/scope.hpp>
#include <boost/python/enum.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osgParticle/ParticleEffect>
#include <osgParticle/ExplosionEffect>

#include "held_ptr.hpp"

using namespace boost::python;

namespace PyOSGParticle {
void init_ExplosionEffect()
{
    class_<osgParticle::ExplosionEffect, osg::ref_ptr<osgParticle::ExplosionEffect>, bases<osgParticle::ParticleEffect> > explosionEffect("ExplosionEffect",
        no_init);

    explosionEffect.def(init<>());
    explosionEffect.def(init<osg::Vec3&>());
    explosionEffect.def(init<osg::Vec3&, float>());
    explosionEffect.def(init<osg::Vec3&, float, float>());

    explosionEffect.def("setDefaults",
            &osgParticle::ExplosionEffect::setDefaults);

    explosionEffect.def("setUpEmitterAndProgram",
            &osgParticle::ExplosionEffect::setUpEmitterAndProgram);

    explosionEffect.def("getEmitter",
            (osgParticle::Emitter * (osgParticle::ExplosionEffect::*)())
            &osgParticle::ExplosionEffect::getEmitter,
            return_value_policy<manage_osg_object>());

    explosionEffect.def("getProgram",
            (osgParticle::Program * (osgParticle::ExplosionEffect::*)())
            &osgParticle::ExplosionEffect::getProgram,
            return_value_policy<manage_osg_object>());
}}

