// Copyright (C) 2002-2005 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/class.hpp>
#include <boost/python/scope.hpp>
#include <boost/python/enum.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osgParticle/ParticleEffect>
#include <osgParticle/FireEffect>

#include "held_ptr.hpp"

using namespace boost::python;

namespace PyOSGParticle {
void init_FireEffect()
{
    class_<osgParticle::FireEffect, osg::ref_ptr<osgParticle::FireEffect>, bases<osgParticle::ParticleEffect> > fireEffect("FireEffect",
        no_init);

    fireEffect.def(init<>());
    fireEffect.def(init<osg::Vec3&>());
    fireEffect.def(init<osg::Vec3&, float>());
    fireEffect.def(init<osg::Vec3&, float, float>());

    fireEffect.def("setDefaults",
            &osgParticle::FireEffect::setDefaults);

    fireEffect.def("setUpEmitterAndProgram",
            &osgParticle::FireEffect::setUpEmitterAndProgram);

    fireEffect.def("getEmitter",
            (osgParticle::Emitter * (osgParticle::FireEffect::*)())
            &osgParticle::FireEffect::getEmitter,
            return_value_policy<manage_osg_object>());

    fireEffect.def("getProgram",
            (osgParticle::Program * (osgParticle::FireEffect::*)())
            &osgParticle::FireEffect::getProgram,
            return_value_policy<manage_osg_object>());
}}



