// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/class.hpp>
#include <boost/python/scope.hpp>
#include <boost/python/enum.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osgParticle/PointPlacer>

#include "held_ptr.hpp"

using namespace boost::python;

namespace PyOSGParticle {
void init_PointPlacer()
{
    class_<osgParticle::PointPlacer, osg::ref_ptr<osgParticle::PointPlacer>, bases<osgParticle::CenteredPlacer> > placer("PointPlacer",
        "A point-shaped particle placer."
        "This placer class uses the center point defined in its base class <CODE>CenteredPlacer</CODE>"
        "to place there all incoming particles.",
        no_init);
    placer.def(init<>());
}
}
