// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/class.hpp>
#include <boost/python/scope.hpp>
#include <boost/python/enum.hpp>

#include <osgParticle/Program>

#include "held_ptr.hpp"

using namespace boost::python;

namespace PyOSGParticle {
void init_Program()
{
    class_<osgParticle::Program, osg::ref_ptr<osgParticle::Program>, bases<osgParticle::ParticleProcessor>, boost::noncopyable > program("Program",
        "An abstract <CODE>ParticleProcessor</CODE> descendant for modifying particles \"on the fly\" "
        "during the cull traversal."
        "Descendants of this class must implement the <CODE>execute()</CODE> method, which should iterate "
        "through all particles in the linked particle system and modify them somehow "
        "(usually updating their velocity vector).",
        no_init);

    // program.def("execute", &osgParticle::Program::execute,
    //     "Execute the program on the particle system. Must be overriden in descendant classes.");
}
}
#if 0
        inline void process(double dt);
        /// Implementation of <CODE>ParticleProcessor::process()</CODE>. Do not call this method by yourself.
        
#endif


