// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/class.hpp>
#include <boost/python/scope.hpp>
#include <boost/python/enum.hpp>

#include <osgParticle/RandomRateCounter>

#include "held_ptr.hpp"

using namespace boost::python;

namespace PyOSGParticle {
void init_RandomRateCounter()
{
    class_<osgParticle::RandomRateCounter, osg::ref_ptr<osgParticle::RandomRateCounter>, bases<osgParticle::VariableRateCounter>, boost::noncopyable > counter("RandomRateCounter",
        no_init);

    counter.def(init<>());

    counter.def("numParticlesToCreate", &osgParticle::RandomRateCounter::numParticlesToCreate,
        "Return the number of particles to be created in this frame");
}
}
