// Copyright (C) 2002-2005 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/class.hpp>
#include <boost/python/scope.hpp>
#include <boost/python/enum.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osgParticle/ParticleEffect>
#include <osgParticle/SmokeEffect>

#include "held_ptr.hpp"

using namespace boost::python;

namespace PyOSGParticle {
void init_SmokeEffect()
{
    class_<osgParticle::SmokeEffect, osg::ref_ptr<osgParticle::SmokeEffect>, bases<osgParticle::ParticleEffect> > smokeEffect("SmokeEffect",
        no_init);

    smokeEffect.def(init<>());
    smokeEffect.def(init<osg::Vec3&>());
    smokeEffect.def(init<osg::Vec3&, float>());
    smokeEffect.def(init<osg::Vec3&, float, float>());

    smokeEffect.def("setDefaults",
            &osgParticle::SmokeEffect::setDefaults);

    smokeEffect.def("setUpEmitterAndProgram",
            &osgParticle::SmokeEffect::setUpEmitterAndProgram);

    smokeEffect.def("getEmitter",
            (osgParticle::Emitter * (osgParticle::SmokeEffect::*)())
            &osgParticle::SmokeEffect::getEmitter,
            return_value_policy<manage_osg_object>());

    smokeEffect.def("getProgram",
            (osgParticle::Program * (osgParticle::SmokeEffect::*)())
            &osgParticle::SmokeEffect::getProgram,
            return_value_policy<manage_osg_object>());
}}


