// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/class.hpp>
#include <boost/python/scope.hpp>
#include <boost/python/enum.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osgParticle/VariableRateCounter>

#include "held_ptr.hpp"

using namespace boost::python;

namespace PyOSGParticle {
void init_VariableRateCounter()
{
    class_<osgParticle::VariableRateCounter, osg::ref_ptr<osgParticle::VariableRateCounter>, bases<osgParticle::Counter>, boost::noncopyable > counter("VariableRateCounter",
        no_init);

    counter.def("getRateRange", &osgParticle::VariableRateCounter::getRateRange,
            "No Doc",
            return_internal_reference<>());

    counter.def("setRateRange", (void (osgParticle::VariableRateCounter::*)(const osgParticle::rangef&))&osgParticle::VariableRateCounter::setRateRange,
            "No Doc");

    counter.def("setRateRange", (void (osgParticle::VariableRateCounter::*)(float, float))&osgParticle::VariableRateCounter::setRateRange,
            "No Doc");
}
}
