// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/module.hpp>
#include <boost/python/def.hpp>

#include <osgParticle/Version>

using namespace boost::python;

namespace PyOSGParticle {
void init_AccelOperator();
void init_CenteredPlacer();
void init_Counter();
void init_Emitter();
void init_ForceOperator();
void init_FluidFrictionOperator();
void init_ModularEmitter();
void init_ModularProgram();
void init_MultiSegmentPlacer();
void init_Operator();
void init_Particle();
void init_ParticleProcessor();
void init_ParticleSystem();
void init_ParticleSystemUpdater();
void init_Placer();
void init_PointPlacer();
void init_Program();
void init_RadialShooter();
void init_RandomRateCounter();
void init_SectorPlacer();
void init_SegmentPlacer();
void init_Shooter();
void init_VariableRateCounter();
void init_range();
void init_ParticleEffect();
void init_ExplosionEffect();
void init_ExplosionDebrisEffect();
void init_FireEffect();
void init_SmokeEffect();
}

using namespace PyOSGParticle;

BOOST_PYTHON_MODULE(_osgParticle)
{
    init_range();
    init_Particle();
    init_ParticleSystem();
    init_ParticleProcessor();
    init_ParticleSystemUpdater();

    init_Operator();
    init_AccelOperator();
    init_FluidFrictionOperator();
    init_ForceOperator();
    
    init_Placer();
    init_CenteredPlacer();
    init_SectorPlacer();
    init_PointPlacer();
    init_SegmentPlacer();
    init_MultiSegmentPlacer();

    init_Emitter();
    init_ModularEmitter();

    init_Program();
    init_ModularProgram();

    init_Shooter();
    init_RadialShooter();

    init_Counter();
    init_VariableRateCounter();
    init_RandomRateCounter();

    init_ParticleEffect();
    init_ExplosionEffect();
    init_ExplosionDebrisEffect();
    init_FireEffect();
    init_SmokeEffect();

    def("GetVersion", (const char *(*)(void)) &osgParticleGetVersion);
    def("GetLibraryName", (const char *(*)(void)) &osgParticleGetLibraryName);
}

#include "module_tail.hpp"

