// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/class.hpp>

#include <osgParticle/range>

using namespace boost::python;

namespace PyOSGParticle {
void init_range()
{
    class_<osgParticle::rangef> rangef("rangef");
    rangef.def(init<const float&, const float&>());
    rangef.def("set", &osgParticle::rangef::set);
    rangef.def("get_random", &osgParticle::rangef::get_random);

    class_<osgParticle::rangev2> rangev2("rangev2");
    rangev2.def(init<const osg::Vec2&, const osg::Vec2&>());
    rangev2.def("set", &osgParticle::rangev2::set);
    rangev2.def("get_random", &osgParticle::rangev2::get_random);

    class_<osgParticle::rangev3> rangev3("rangev3");
    rangev3.def(init<const osg::Vec3&, const osg::Vec3&>());
    rangev3.def("set", &osgParticle::rangev3::set);
    rangev3.def("get_random", &osgParticle::rangev3::get_random);

    class_<osgParticle::rangev4> rangev4("rangev4");
    rangev4.def(init<const osg::Vec4&, const osg::Vec4&>());
    rangev4.def("set", &osgParticle::rangev4::set);
    rangev4.def("get_random", &osgParticle::rangev4::get_random);
}
}
