// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.

#include <boost/python/module.hpp>
#include <boost/python/def.hpp>

#include <osgProducer/Version>

using namespace boost::python;

namespace PyOSG{

void init_OsgCameraGroup();
void init_OsgSceneHandler();
void init_Viewer();
void init_EventAdapter();

void __init_osgProducer()
{
#if 0
    def("GetVersion", &osgProducerGetVersion);
    def("GetLibraryName", &osgProducerGetLibraryName);
#endif
    init_OsgSceneHandler();
    init_OsgCameraGroup();
    init_Viewer();
    init_EventAdapter();
}
}

using namespace PyOSG;

BOOST_PYTHON_MODULE(_osgProducer)
{
    __init_osgProducer();
}
#include "module_tail.hpp"
