// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.

#include <boost/python/detail/wrap_python.hpp>

#include "PythonInterpreter.hpp"

#ifdef linux
#include <dlfcn.h>
#endif

#include <stdio.h>
#include <iostream>

using namespace osgScript;

PythonInterpreter* PythonInterpreter::_instance = 0;

PythonInterpreter* PythonInterpreter::Instance()
{
        if (_instance == 0) {
                _instance = new PythonInterpreter();
        }
        return _instance;
}

void PythonInterpreter::runSimpleString(const char * cmd)
{
        PyRun_SimpleString(const_cast<char *>(cmd));
}

PythonInterpreter::PythonInterpreter()
{
    // Need to do this to resolve undefined variables, only for linux
#ifdef linux
    if (dlopen("libpython2.2.so", RTLD_GLOBAL | RTLD_NOW) == NULL) {
            perror("dlopen");
    }
#endif
    Py_Initialize();

    /***
    void * osghandle = dlopen("/usr/local/lib/python2.2/site-packages/PyOSG/osg.so", RTLD_GLOBAL | RTLD_NOW);
    if (osghandle== NULL) {
            perror("dlopen");
            return;
    }
    std::cerr << "Calling initosg";
    void (*initosg)(void);
    initosg=(void(*)(void))dlsym(osghandle, "initosg");
    if (initosg == NULL) {
            std::cerr << "Unable to get initosg\n";
        return;
    }
    (*initosg)();
    ***/
}

PythonInterpreter::~PythonInterpreter()
{
    Py_Finalize();
}
