// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.

#include <boost/python/class.hpp>
#include <boost/python/return_internal_reference.hpp>
#include <boost/ref.hpp>

#include <string>
#include <iostream>

#include <osgSim/LightPointNode>

#include "held_ptr.hpp"

using namespace boost::python;


namespace PyOSGSim {
void init_LightPointNode()
{
    class_<osgSim::LightPointNode, osg::ref_ptr<osgSim::LightPointNode>, bases<osg::Node> > lightpointnode("LightPointNode", 
        no_init);
    lightpointnode.def(init<>());

    lightpointnode.def("addLightPoint",&osgSim::LightPointNode::addLightPoint);
}
}
