// Copyright (C) 2002-2005 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/module.hpp>
#include <boost/python/def.hpp>

#include <osgSim/Version>

using namespace boost::python;

namespace PyOSGSim {
void init_LightPoint();
void init_LightPointNode();
void init_ScalarBar();
void init_ScalarsToColors();
void init_ColorRange();
void init_SphereSegment();
void init_BlinkSequence();
void init_Impostor();
void init_ImpostorSprite();
void init_OverlayNode();
}

using namespace PyOSGSim;

BOOST_PYTHON_MODULE(_osgSim)
{
    init_LightPoint();
    init_LightPointNode();
    init_SphereSegment();
    init_BlinkSequence();
    init_Impostor();
    init_ImpostorSprite();
    init_ScalarBar();
    init_ScalarsToColors();
    init_ColorRange();
    init_OverlayNode();

    def("GetVersion", (const char *(*)()) &osgSimGetVersion);
    def("GetLibraryName", (const char *(*)()) &osgSimGetLibraryName);
}

#include "module_tail.hpp"

