// Copyright (C) 2005 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <iostream>
#include <boost/python.hpp>

#include <osg/Referenced>
#include <osg/ref_ptr>

#include <osgSound/Sample>

#include "held_ptr.hpp"

using namespace boost::python;


namespace PyOSGSound {

void init_Sample()
{
    class_<osgSound::Sample, osg::ref_ptr<osgSound::Sample>, bases<osg::Referenced> > sample("Sample", no_init);
    sample
        .def(init<const std::string&, optional<bool, bool, bool> >(args("fname", "streaming", "two_d", "hardware")))

        .def("valid", &osgSound::Sample::valid)
        ;
}
}

