// Copyright (C) 2005 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <iostream>
#include <boost/python.hpp>

#include <osg/Referenced>
#include <osg/ref_ptr>

#include <osgSound/SoundNode>

#include "held_ptr.hpp"

using namespace boost::python;

namespace {
};


namespace PyOSGSound {

void init_SoundNode()
{
    class_<osgSound::SoundNode, osg::ref_ptr<osgSound::SoundNode>, bases<osg::Node> > sound_node("SoundNode", no_init);
    sound_node
        .def(init<>())

        .def("setSoundState", &osgSound::SoundNode::setSoundState)

        // .def("getSoundState", &osgSound::SoundNode::getSoundState,
        //         return_value_policy<manage_osg_object>())
        ;
}
}



