// Copyright (C) 2002-2005 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python.hpp>

#include <osgSound/Version>

using namespace boost::python;
using namespace osgSound;

namespace PyOSGSound {
    void init_Sample();
    void init_SoundState();
    void init_SoundNode();
    void init_SoundRoot();
}

using namespace PyOSGSound;

BOOST_PYTHON_MODULE(_osgSound)
{
    def("GetVersion", &getVersion);
    def("GetLibraryName", &getLibraryName);

    init_Sample();
    init_SoundState();
    init_SoundNode();
    init_SoundRoot();
}

#include "module_tail.hpp"

