// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/class.hpp>
#include <boost/python/return_internal_reference.hpp>

#include <osgUtil/CubeMapGenerator>

using namespace boost::python;

namespace {
void generateMap(osgUtil::CubeMapGenerator * self)
{
    self->generateMap();
}

class CubeMapGenerator : public osgUtil::CubeMapGenerator {
    public :
        virtual osg::Vec4 compute_color(const osg::Vec3 &R) const { return osg::Vec4(); }
};

}

namespace PyOSGUtil {
void init_CubeMapGenerator()
{
    class_<osgUtil::CubeMapGenerator, CubeMapGenerator, bases<osg::Referenced>, boost::noncopyable >("CubeMapGenerator", no_init)
        .def("getImage",
            (osg::Image *(osgUtil::CubeMapGenerator::*)(osg::TextureCubeMap::Face))
            &osgUtil::CubeMapGenerator::getImage,
            return_internal_reference<>())
        .def("generateMap", &generateMap)
        .def("generateMap", (void (osgUtil::CubeMapGenerator::*)(bool)) &osgUtil::CubeMapGenerator::generateMap)
        ;
}
}

