// Copyright (C) 2002-2003 brett hartshorn (bhartsho@yahoo.com)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/def.hpp>
#include <boost/python/class.hpp>
#include <boost/python/return_value_policy.hpp>
#include <boost/python/return_internal_reference.hpp>
#include <boost/ref.hpp>

#include <osgUtil/DelaunayTriangulator>

#include "held_ptr.hpp"

using namespace boost::python;

namespace PyOSGUtil {
void init_DelaunayTriangulator()
{
    class_<osgUtil::DelaunayTriangulator, osg::ref_ptr<osgUtil::DelaunayTriangulator>, bases<osg::Referenced>, boost::noncopyable>
    ("DelaunayTriangulator", no_init)
    .def(init<>())
    .def("getInputPointArray", 
        (osg::Vec3Array * (osgUtil::DelaunayTriangulator::*)())
        &osgUtil::DelaunayTriangulator::getInputPointArray, return_internal_reference<>())
    .def("setInputPointArray", &osgUtil::DelaunayTriangulator::setInputPointArray)

    .def("getOutputNormalArray", 
        (osg::Vec3Array * (osgUtil::DelaunayTriangulator::*)())
        &osgUtil::DelaunayTriangulator::getOutputNormalArray, return_internal_reference<>())
    .def("setOutputNormalArray", &osgUtil::DelaunayTriangulator::setOutputNormalArray)
    
    .def("getTriangles", 
        (osg::DrawElementsUInt * (osgUtil::DelaunayTriangulator::*)())
        &osgUtil::DelaunayTriangulator::getTriangles, return_internal_reference<>())

    .def("triangulate", &osgUtil::DelaunayTriangulator::triangulate)
    ;
}
}


