// Copyright (C) 2002-2003 Brett Hartshorn (bhartsho@yahoo.com)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/def.hpp>
#include <boost/python/class.hpp>
#include <boost/python/return_internal_reference.hpp>
#include <boost/ref.hpp>

#include <osgUtil/RenderLeaf>

using namespace boost::python;

namespace PyOSGUtil {
void init_RenderLeaf()
{
    class_<osgUtil::RenderLeaf, bases<osg::Referenced>, boost::noncopyable>
    ("RenderLeaf", no_init)
    .def(init<osg::Drawable*, osg::RefMatrix*, osg::RefMatrix*, float>())
    .def("set", &osgUtil::RenderLeaf::set)
    .def("reset", &osgUtil::RenderLeaf::reset)
    .def("render", &osgUtil::RenderLeaf::render)
    ;
}
}


