// Copyright (C) 2002-2003 Brett Hartshorn (bhartsho@yahoo.com)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/def.hpp>
#include <boost/python/class.hpp>
#include <boost/python/return_internal_reference.hpp>
#include <boost/ref.hpp>

#include <osgUtil/Simplifier>

#include "held_ptr.hpp"

using namespace boost::python;

namespace PyOSGUtil {
void init_Simplifier()
{
    class_<osgUtil::Simplifier, osg::ref_ptr<osgUtil::Simplifier>, bases<osg::NodeVisitor>, boost::noncopyable>
    ("Simplifier", no_init)
        .def(init<float, float>())
        .def("setSampleRatio", &osgUtil::Simplifier::setSampleRatio)
        .def("getSampleRatio", &osgUtil::Simplifier::getSampleRatio)
        .def("setMaximumError", &osgUtil::Simplifier::setMaximumError)
        .def("getMaximumError", &osgUtil::Simplifier::getMaximumError)
        .def("continueSimplification", &osgUtil::Simplifier::continueSimplification)
        .def("simplify", (void (osgUtil::Simplifier::*)(osg::Geometry&))
        &osgUtil::Simplifier::simplify)
        ;
}
}






