// Copyright (C) 2002-2003 Brett Hartshorn (bhartsho@yahoo.com)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/def.hpp>
#include <boost/python/class.hpp>
#include <boost/python/return_value_policy.hpp>
#include <boost/python/return_internal_reference.hpp>
#include <boost/ref.hpp>

#include <osgUtil/TangentSpaceGenerator>

#include "held_ptr.hpp"

using namespace boost::python;

namespace PyOSGUtil {
void init_TangentSpaceGenerator()
{
    class_<osgUtil::TangentSpaceGenerator, bases<osg::Referenced> , boost::noncopyable>
    ("TangentSpaceGenerator", no_init)
    
    .def("generate", &osgUtil::TangentSpaceGenerator::generate)

    .def("getTangentArray", 
        (osg::Vec4Array * (osgUtil::TangentSpaceGenerator::*)())
        &osgUtil::TangentSpaceGenerator::getTangentArray, return_internal_reference<>())
    .def("setTangentArray", &osgUtil::TangentSpaceGenerator::setTangentArray)

    .def("getNormalArray", 
        (osg::Vec4Array * (osgUtil::TangentSpaceGenerator::*)())
        &osgUtil::TangentSpaceGenerator::getNormalArray, return_internal_reference<>())
    .def("setNormalArray", &osgUtil::TangentSpaceGenerator::setNormalArray)
    
    .def("getBinormalArray", 
        (osg::Vec4Array * (osgUtil::TangentSpaceGenerator::*)())
        &osgUtil::TangentSpaceGenerator::getBinormalArray, return_internal_reference<>())
    .def("setBinormalArray", &osgUtil::TangentSpaceGenerator::setBinormalArray) 
    ;
}
}

