// Copyright (C) 2002-2003 Brett Hartshorn (bhartsho@yahoo.com)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
//

#include <boost/python/def.hpp>
#include <boost/python/class.hpp>
#include <boost/python/list.hpp>
#include <boost/python/extract.hpp>
#include <boost/python/iterator.hpp>
#include <boost/python/return_value_policy.hpp>
#include <boost/python/return_internal_reference.hpp>
#include <boost/python/manage_new_object.hpp>
#include <boost/python/detail/api_placeholder.hpp>
#include <boost/ref.hpp>
#include <boost/lexical_cast.hpp>

#include <osgUtil/TriStripVisitor>

#include <string>
#include <iostream>

#include "held_ptr.hpp"

using namespace boost::python;

namespace PyOSGUtil {
void init_TriStripVisitor()
{
    class_<osgUtil::TriStripVisitor, bases<osg::NodeVisitor> >("TriStripVisitor")
        .def("stripify", 
            (void (osgUtil::TriStripVisitor::*)(osg::Geometry&))
            &osgUtil::TriStripVisitor::stripify)
        .def("stripify", 
            (void (osgUtil::TriStripVisitor::*)())
            &osgUtil::TriStripVisitor::stripify)

        .def("apply", &osgUtil::TriStripVisitor::apply)

        .def("setCacheSize", &osgUtil::TriStripVisitor::setCacheSize)

        .def("setMinStripSize", &osgUtil::TriStripVisitor::setMinStripSize)

        .def("setGenerateFourPointPrimitivesQuads", &osgUtil::TriStripVisitor::setGenerateFourPointPrimitivesQuads)
        .def("getGenerateFourPointPrimitivesQuads", &osgUtil::TriStripVisitor::getGenerateFourPointPrimitivesQuads)
    ;
}
}


