// Copyright (C) 2002-2003 Gideon May (gideon@computer.org)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.

#include <boost/python/def.hpp>
#include <boost/python/class.hpp>

#include <osgUtil/UpdateVisitor>

#include "NodeVisitor.hpp"

using namespace boost::python;

namespace {
osgUtil::UpdateVisitor * asUpdateVisitor(osg::NodeVisitor * nv)
{
    return dynamic_cast<osgUtil::UpdateVisitor*>(nv);
}
} // namespace

namespace PyOSGUtil {
void init_UpdateVisitor()
{
    def("asUpdateVisitor", &asUpdateVisitor, return_internal_reference<>());

    class_<osgUtil::UpdateVisitor, bases<osg::NodeVisitor>, boost::noncopyable > update_visitor("UpdateVisitor");

    update_visitor
        .def("reset", &osgUtil::UpdateVisitor:: reset)
        ;
}
}
